/*
 * Copyright 2016 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.guvnor.ala.ui.preferences;

import java.lang.RuntimeException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.annotation.Generated;

import org.jboss.errai.common.client.api.annotations.MapsTo;
import org.jboss.errai.common.client.api.annotations.Portable;
import org.uberfire.preferences.shared.annotations.PortablePreference;
import org.uberfire.preferences.shared.bean.BasePreferencePortable;
import org.uberfire.preferences.shared.PropertyFormType;
import org.uberfire.preferences.shared.PropertyValidator;
import org.uberfire.mvp.Command;
import org.uberfire.mvp.ParameterizedCommand;

@Portable( mapSuperTypes = true )
@PortablePreference
@Generated("org.uberfire.ext.preferences.processors.WorkbenchPreferenceProcessor")
/*
* WARNING! This class is generated. Do not modify.
*/
public class ProvisioningPreferencesPortableGeneratedImpl extends ProvisioningPreferences implements BasePreferencePortable<ProvisioningPreferences> {

    public ProvisioningPreferencesPortableGeneratedImpl() {
    }

    public ProvisioningPreferencesPortableGeneratedImpl( @MapsTo("providerTypeEnablements") java.util.Map<org.guvnor.ala.ui.model.ProviderType,java.lang.Boolean> providerTypeEnablements ) {
        setProviderTypeEnablements( providerTypeEnablements );
    }

    @Override
    public Class<ProvisioningPreferences> getPojoClass() {
        return ProvisioningPreferences.class;
    }

    @Override
    public String identifier() {
        return "ProvisioningPreferences";
    }

    @Override
    public String[] parents() {
        return new String[] { "" };
    }

    @Override
    public String bundleKey() {
        return "ProvisioningPreferences";
    }

    @Override
    public void set( String property, Object value ) {
        if ( property.equals( "providerTypeEnablements" ) ) {
            setProviderTypeEnablements( (java.util.Map<org.guvnor.ala.ui.model.ProviderType,java.lang.Boolean>) value );
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Object get( String property ) {
        if ( property.equals( "providerTypeEnablements" ) ) {
            return getProviderTypeEnablements();
        } else
        {
            throw new RuntimeException( "Unknown property: " + property );
        }
    }

    @Override
    public Map<String, PropertyFormType> getPropertiesTypes() {
        Map<String, PropertyFormType> propertiesTypes = new HashMap<>();

        propertiesTypes.put( "providerTypeEnablements", PropertyFormType.TEXT);

        return propertiesTypes;
    }

    @Override
    public Map<String, List<PropertyValidator>> getPropertiesValidators() {
        Map<String, List<PropertyValidator>> validatorsByProperty = new HashMap<>();


        return validatorsByProperty;
    }

    @Override
    public boolean equals( final Object o ) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }

        final ProvisioningPreferencesPortableGeneratedImpl that = (ProvisioningPreferencesPortableGeneratedImpl) o;

        if ( getProviderTypeEnablements() != null ? !getProviderTypeEnablements().equals( that.getProviderTypeEnablements() ) : that.getProviderTypeEnablements() != null ) {
            return false;
        }

        return true;
    }

    @Override
    public int hashCode() {
        int result = 0;

        result = 31 * result + ( getProviderTypeEnablements() != null ? getProviderTypeEnablements().hashCode() : 0 );
        result = ~~result;

        return result;
    }

    @Override
    public boolean isPersistable() {
        return true;
    }
}
